unit MAIN;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    FileNew1: TAction;
    FileSave1: TAction;
    FileExit1: TAction;
    FileOpen1: TAction;
    FileSaveAs1: TAction;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    HelpAbout1: TAction;
    FileClose1: TWindowClose;
    WindowTileVertical1: TWindowTileVertical;
    WindowTileItem2: TMenuItem;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton9: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolButton_Run: TToolButton;
    ToolButton13: TToolButton;
    ToolButton12: TToolButton;
    ToolButton14: TToolButton;
    ImageList_Func: TImageList;
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure ToolButton_RunClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FCaptureFlag: boolean;
    procedure CreateMDIChild(const Name: string);
    procedure ON_HOTKEY(var m: TMessage); message WM_HOTKEY;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses CHILDWIN, about, light, zlportio;

procedure TMainForm.CreateMDIChild(const Name: string);
var
  Child: TMDIChild;
begin
  { create a new MDI child window }
  Child := TMDIChild.Create(Application);
  Child.Caption := Name;
  if FileExists(Name) then
    Child.Memo1.Lines.LoadFromFile(Name);
end;

procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
  CreateMDIChild('NONAME' + IntToStr(MDIChildCount + 1));
end;

procedure TMainForm.FileOpen1Execute(Sender: TObject);
begin
  if OpenDialog.Execute then
    CreateMDIChild(OpenDialog.FileName);
end;

procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.ToolButton_RunClick(Sender: TObject);
var
  data: integer;
  Count: Cardinal;
begin
  FCaptureFlag := true;

  Form1.Edit3.Text := 'FF';
  Form1.Button3.Click;

  TToolButton(Sender).Down := true;

  data := Form1.ReadStatus;
  Form1.ShowPin(data, Form1.GroupBox1);
  Form1.Edit2.Text := IntToHex(data, ZLIO_BYTE);


  Count := 0;
  while FCaptureFlag do
  begin
    Inc(Count);
    data := Form1.ReadData;
    Form1.ShowPin(data, Form1.GroupBox2);
    Form1.Edit1.Text := IntToHex(data, ZLIO_BYTE);

    Application.HandleMessage;

    if (data and $40) = 0 then
      ShowMessage('RDY_TO_TST!!');

    {
    if Count >= 10000 then
    begin
      Application.ProcessMessages;
      Count := 0;
    end;


    if Count >= 4294967295 then
    begin
      ToolButton_Run.Down := false;
      break;
    end;
    }
  end;

end;

const
  REG_HOTKEY_ID = 99999;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FCaptureFlag := false;
  RegisterHotKey(Handle, REG_HOTKEY_ID, MOD_CONTROL, integer('C'));
end;

const
  CONTROL_KEY = 123;
const
  UCHAR_C_KEY = 67;
const
  LCHAR_C_KEY = 99;

procedure TMainForm.ON_HOTKEY(var m: TMessage);
begin
  FCaptureFlag := false;
  ToolButton_Run.Down := false;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  UnregisterHotKey(Handle, REG_HOTKEY_ID);
end;

end.

