unit light;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, zlportio, Main;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    Shape8: TShape;
    StaticText8: TStaticText;
    GroupBox2: TGroupBox;
    Shape9: TShape;
    Shape10: TShape;
    Shape11: TShape;
    Shape12: TShape;
    Shape13: TShape;
    Shape14: TShape;
    Shape15: TShape;
    Shape16: TShape;
    StaticText9: TStaticText;
    StaticText10: TStaticText;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    StaticText13: TStaticText;
    StaticText14: TStaticText;
    StaticText15: TStaticText;
    StaticText16: TStaticText;
    GroupBox3: TGroupBox;
    Shape17: TShape;
    Shape18: TShape;
    Shape19: TShape;
    Shape20: TShape;
    Shape21: TShape;
    Shape22: TShape;
    Shape23: TShape;
    Shape24: TShape;
    StaticText17: TStaticText;
    StaticText18: TStaticText;
    StaticText19: TStaticText;
    StaticText20: TStaticText;
    StaticText21: TStaticText;
    StaticText22: TStaticText;
    StaticText23: TStaticText;
    StaticText24: TStaticText;
    Timer1: TTimer;
    Timer2: TTimer;
    Timer3: TTimer;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    Label4: TLabel;
    Edit4: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
    _dPort, _cPort, _sPort: Integer;
  public
    { Public declarations }
    procedure SetPinRed(GroupBox: TGroupBox);
    procedure SetPinWhite(GroupBox: TGroupBox);
    procedure SetPort(dPort, sPort, cPort: Integer);
    procedure ShowPin(sData: Integer; GroupBox: TGroupBox);
    function GetShapeIndex(GroupBox: TGroupBox): TStrings;
    function ReadData: Integer;
    function ReadStatus: Integer;
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}

uses Vic_Res;

function GetLPTPortAddr_NT(LPTName: string): Word;
var
  VicRes: TVicRes;
  i, j: integer;
begin
  Result := 0;

  try
    VicRes := TVicRes.Create;
    // VicRes.SearchByClassName('Ports');

    VicRes.SearchByHardwareKey('ACPI\PNP0401');

    for i := 1 to VicRes.Devices do
      if StrPos(PAnsiChar(VicRes.DeviceDescriptor[i]), PAnsiChar(LPTName)) <> nil
        then
      begin
        // Search For First Base I/O Address
        for j := 1 to 8 do
          if (VicRes.PortBase[j] <> $FFFF) and (VicRes.PortBase[j] <> 0) then
          begin
            Result := VicRes.PortBase[j];
            break;
          end;

      end;

  finally
    FreeAndNil(VicRes);
  end;
end;

//-----------------------------------------------------

procedure delay(msecs: DWORD); stdcall;
var
  rStart, rEnd, rFreq: TLargeInteger;
begin
  QueryPerformanceFrequency(rFreq);
  rEnd := Round(msecs * rFreq / 1000);

  QueryPerformanceCounter(rStart);
  rEnd := rEnd + rStart;

  repeat
    QueryPerformanceCounter(rFreq);
  until rFreq >= rEnd;
end;

function TForm1.GetShapeIndex(GroupBox: TGroupBox): TStrings;
var
  j: Integer;
  ShapeArr: TStrings;
begin
  ShapeArr := TStringList.Create;

  for j := 0 to GroupBox.ControlCount - 1 do
  begin
    if GroupBox.Controls[j].ClassType = TShape then
    begin
      ShapeArr.Add(IntToStr(j));
    end;
  end;

  Result := ShapeArr;

end;

procedure TForm1.ShowPin(sData: Integer; GroupBox: TGroupBox);
var
  i: Integer;
  ShapeIndex: TStrings;
  shape: TShape;
begin
  ShapeIndex := GetShapeIndex(GroupBox);

  for i := 0 to 7 do
  begin
    shape := TShape(GroupBox.Controls[StrToInt(ShapeIndex.Strings[i])]);

    if (sData and StrToInt('$01') = StrToInt('$01')) then
      shape.Brush.Color := clRed
    else
      shape.Brush.Color := clWhite;

    sData := sData shr 1;
  end;
end;

procedure TForm1.SetPort(dPort, sPort, cPort: Integer);
begin
  _dPort := dPort;
  _sPort := sPort;
  _cPort := cPort;
end;

procedure TForm1.SetPinRed(GroupBox: TGroupBox);
var
  j: Integer;
  shape: TShape;
begin
  for j := 0 to GroupBox.ControlCount - 1 do
  begin
    if GroupBox.Controls[j].ClassType = TShape then
    begin
      shape := TShape(GroupBox.Controls[j]);
      shape.Brush.Color := clRed;
    end;
  end;
end;

procedure TForm1.SetPinWhite(GroupBox: TGroupBox);
var
  j: Integer;
  shape: TShape;
begin
  for j := 0 to GroupBox.ControlCount - 1 do
  begin
    if GroupBox.Controls[j].ClassType = TShape then
    begin
      shape := TShape(GroupBox.Controls[j]);
      shape.Brush.Color := clWhite;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  LPT_PortBase:Word;
begin
  if ZLIOStarted then
    MainForm.StatusBar.SimpleText := 'Driver successfully started !'
  else
  begin
    MainForm.StatusBar.SimpleText := 'Couldnt start driver. Something wrong !';
    ShowMessage('Lk Install DDK Driver,lƥѽЭsҰʵ{!!');
  end;

  // Direct IO;
  zliosetiopm(TRUE);

  LPT_PortBase := GetLPTPortAddr_NT('LPT1');

  // SetPort(StrToInt('$0378'), StrToInt('$0379'), StrToInt('$037a'));

  SetPort(LPT_PortBase, LPT_PortBase+1, LPT_PortBase+2);

  // zlioportwrite(_cport,ZLIO_BYTE,strToint('$' + '20'));
  // timeBeginPeriod(100);
  // TimerID := timeSetEvent(500,100,@SetDataPinRed,0,TIME_PERIODIC);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  // timeKillEvent(TimerID);
  // timePeriod(100);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  SetPinRed(GroupBox1);
  SetPinRed(GroupBox2);
  SetPinRed(GroupBox3);
  MainForm.StatusBar.SimpleText := 'Software Pin Initialization...';
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  SetPinWhite(GroupBox1);
  SetPinWhite(GroupBox2);
  SetPinWhite(GroupBox3);
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
  SetPinWhite(GroupBox1);
  SetPinWhite(GroupBox2);
  SetPinWhite(GroupBox3);

  MainForm.StatusBar.SimpleText := 'Software Pin Initialization Finish!!';
  Button4.Click;

  Timer1.Destroy;
  Timer2.Destroy;
  Timer3.Destroy;

end;

procedure TForm1.Button4Click(Sender: TObject);
var
  data: Integer;
begin
  setthreadpriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  data := zlioportread(_sPort, ZLIO_BYTE);
  Edit2.Text := inttohex(data, ZLIO_BYTE);
  ShowPin(data, GroupBox1);

  setthreadpriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  data := zlioportread(_cPort, ZLIO_BYTE);
  Edit3.Text := inttohex(data, ZLIO_BYTE);
  ShowPin(data, GroupBox3);

  setthreadpriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  data := zlioportread(_dPort, ZLIO_BYTE);
  Edit1.Text := inttohex(data, ZLIO_BYTE);
  ShowPin(data, GroupBox2);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  zlioportwrite(_dport, ZLIO_BYTE, strToint('$' + Edit4.text));
  Button4.Click;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  zlioportwrite(_cPort, ZLIO_BYTE, strToint('$' + Edit3.Text));
  // zlioportwrite(_sPort, ZLIO_BYTE, strToint('$' + Edit2.Text));
  Button4.Click;
end;

function TForm1.ReadData: integer;
begin
  Result := 0;
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  Result := zlioportread(_dPort, ZLIO_BYTE);
end;

function TForm1.ReadStatus: integer;
begin
  Result := 0;
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  Result := zlioportread(_sPort, ZLIO_BYTE);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  zlioportwrite(_sPort, ZLIO_BYTE, strToint('$' + Edit2.Text));
  Button4.Click;
end;

end.

